'use strict';

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var HTTPStatus = require('http-status');

var _require = require('./utils/helpers'),
    expect = _require.expect;

module.exports.Response = function (_Error) {
  _inherits(Response, _Error);

  function Response() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        message = _ref.message,
        _ref$status = _ref.status,
        status = _ref$status === undefined ? HTTPStatus.INTERNAL_SERVER_ERROR : _ref$status,
        data = _ref.data;

    _classCallCheck(this, Response);

    expect({ name: 'message', value: message, type: 'string' });
    expect({ name: 'status', value: status, type: 'number' });
    expect({ name: 'data', value: data, type: 'object', optional: true });
    var code = void 0;
    if (status >= 500 && status < 600) {
      code = 'error';
    } else if (status >= 400 && status < 500) {
      code = 'fail';
    } else {
      throw new Error('Expected "status" parameter to be a number between 400 and 600 but got ' + status + '.');
    }

    var _this = _possibleConstructorReturn(this, (Response.__proto__ || Object.getPrototypeOf(Response)).call(this, message || 'Error has occurred with status ' + (status || 'unknown') + '.'));

    _this.status = status;
    _this.code = code;
    if (data) {
      _this.data = data;
    }
    Error.captureStackTrace(_this, Response);
    return _this;
  }

  return Response;
}(Error);